stages:
  - docker
  - qa
  - test

image: $CI_REGISTRY_IMAGE/docker-compose
services:
  - docker:dind

cache:
  key:
    files:
      - front/package.json
      - back/package.json
  paths:
    - front/node_modules
    - back/node_modules

variables:
  DOCKER_DRIVER: overlay2
  COMPOSE_FILE: "docker-compose.yml:docker-compose.gitlab-ci.yml"

.template-load-gitlab-image: &internal-image
  before_script:
    - cp .env.gitlab-ci .env
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    - docker-compose pull na3_back na3_front na3_etwin na3_db || true

build-docker-images:
  <<: *internal-image
  stage: docker
  script:
    - docker-compose build --pull
    - docker-compose push
  only:
    - master


lint:
  stage: qa
  <<: *internal-image
  script:
    - make ci
    - make lint


test:
  stage: test
  <<: *internal-image
  script:
    - make ci
    - make test
